<?php
/**
* @author   Vasatko
* @version  1.0
* @remarks  Copyright (C) 2011 Vasatko
* @remarks  Licensed under GNU/GPLv3, see http://www.gnu.org/licenses/gpl-3.0.html
* @see      http://vasatko.net/joomla/mapycz
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
* MapyCZ Model for Marker
*/
class mapyczModelMarker extends JModelLegacy {
	
	public $map;
	public $marker;
	
	/** load marker data from database */
	public function loadMarker($id=null){
		try{
		
			// load db
			$db = $this->getDbo();
			$query = $db->getQuery(true);
		
			// set query for select all data about selected map
			$query->select('*');
			$query->from('#__mapycz_marks');
			$query->where('id = '.$db->quote($id));
		
			// set query and create query
			$db->setQuery($query);		
			$this->marker = $db->loadObject();
		
			//echo nl2br(str_replace('#__','jos_',$query));
		
		}catch (Exception $e){
			echo $e->getMessage();exit;
			$this->setError($e->getMessage());
			return false;
		}
	}

	/** set map id and load data about map */
	public function setMapId($id=null){
		if($this->map==null){
			$this->map = new stdClass;
		}
		$this->map->id = $id;
		
		try{
		
			// load db
			$db = $this->getDbo();
			$query = $db->getQuery(true);
		
			// set query for select all data about selected map
			$query->select('*');
			$query->from('#__mapycz');
			$query->where('id = '.$db->quote($id));
		
			// set query and create query
			$db->setQuery($query);		
			$this->map = $db->loadObject();
		
			//echo nl2br(str_replace('#__','jos_',$query));
		
		}catch (Exception $e){
			echo $e->getMessage();exit;
			$this->setError($e->getMessage());
			return false;
		}
	}

	/** return map data */
	public function getMap(){
		return $this->map;
	}

	/** return marker data */
	public function getMark(){
		return $this->marker;
	}
		
	/** create empty marker data */
	public function newMarker() {
		
		$this->marker = new stdClass;
		$this->marker->id = "";
		$this->marker->mapId = $this->map->id;
		$this->marker->shortcut = "";
		$this->marker->color = "red";
		$this->marker->title = "";
		$this->marker->link = "";
		$this->marker->text = "";
		$this->marker->longitude = $this->map->longitude;
		$this->marker->latitude = $this->map->latitude;
	
	}
	
	/** save new or selected marker */
	public function editMarker($id,$mapId,$shortcut,$color,$title,$link,$text,$longitude,$latitude) {
		try{
			
			// create database object
			$db = $this->getDbo();
			
			// if is new mark
			if($id==""){
			
				// set query for insert data
				$db->setQuery(
					'INSERT INTO #__mapycz_marks '.
						'(`id`, `mapId`, `shortcut`, `color`, `title`, `link`, `text`, `latitude`, `longitude`) '.
					'VALUES '.
						'(NULL, '.$db->quote($mapId).', '.$db->quote($shortcut).', '.$db->quote($color).', '.$db->quote($title).', '.$db->quote($link).', '.$db->quote($text).', '.$db->quote($latitude).', '.$db->quote($longitude).
					');'
				);
			
			// if is exist mark
			}else{
				
				// set query for update data
				$db->setQuery(
					'UPDATE #__mapycz_marks SET '. 
						'shortcut = '.$db->quote($shortcut).','.
						'color = '.$db->quote($color).','.
						'title = '.$db->quote($title).','.
						'link = '.$db->quote($link).','.
						'text = '.$db->quote($text).','.
						'longitude = '.$db->quote($longitude).','.
						'latitude = '.$db->quote($latitude).''.
					' WHERE id = '.$id.''
				);
			}
			
			// execute query
			if (!$db->query()) {
				echo $db->getErrorMsg();
				throw new Exception($db->getErrorMsg());
			}

		}catch (Exception $e){
			echo $e->getMessage();exit;
			$this->setError($e->getMessage());
			return false;
		}
	}


	/** save marker(s) positions */
	public function massSavePosition($markers) {
		try{
			
			// get dabase object
			$db = $this->getDbo();
		
			// for each marker
			foreach($markers as $id=>$data){
					
				// set query for update data
				$db->setQuery(
					'UPDATE #__mapycz_marks SET '. 
						'longitude = '.$data['lon'].','.
						'latitude = '.$data['lat'].''.
					' WHERE id = '.$id.''
				);
				
				// execute query
				if (!$db->query()) {
					echo $db->getErrorMsg();
					throw new Exception($db->getErrorMsg());
				}
			}
			
		}catch (Exception $e){
			echo $e->getMessage();exit;
			$this->setError($e->getMessage());
			return false;
		}
	}
	
	/** delete selected marker(s) */
	public function deleteMarker($ids) {
		try{
			
			// get dabase object
			$db = $this->getDbo();
		
			// for each selected map
			foreach($ids as $id){
				
				// create delete query
				$db->setQuery(
					'DELETE FROM #__mapycz_marks WHERE id = '.$id.''
				);
				
				// execute query
				if (!$db->query()) {
					echo $db->getErrorMsg();
					throw new Exception($db->getErrorMsg());
				}
			}
			
		}catch (Exception $e){
			echo $e->getMessage();exit;
			$this->setError($e->getMessage());
			return false;
		}
	}
		
}
