<?php
/**
* @author   Vasatko
* @version  1.0
* @remarks  Copyright (C) 2011 Vasatko
* @remarks  Licensed under GNU/GPLv3, see http://www.gnu.org/licenses/gpl-3.0.html
* @see      http://vasatko.net/joomla/mapycz
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.modellist' );

/**
* MapyCZ Model for mareker list
*/
class mapyczModelMarkers extends JModelList {
	
	protected $map;
	
	/** check if plugin is published */
	public function pluginCheck(){
	
		$state = false;
		$plugin = JPluginHelper::getPlugin("content", "mapycz");
		if($plugin->name=="mapycz")
			$state = true;		
		return $state;
	
	}
	
	public function setMapId($id=null){
		$this->map->id = $id;
	}

	public function getMap(){
		return $this->map;
	}
	
	public function getAllMaps(){
	
		// Create a new query object.
		$db = $this->getDbo();
		$query = $db->getQuery(true);

		// Select the required fields from the table.
		$query->select('m.id, m.name, m.latitude, m.longitude, (SELECT COUNT(id) FROM #__mapycz_marks AS mm WHERE mm.mapId=m.id) AS mark_count');
		$query->from('#__mapycz AS m');
		
		// set query and create query
		$db->setQuery($query);		
		return $db->loadObjectList();
		
	}
	
	public function __construct($config = array()){
		$this->map=new stdClass;
		
		if (empty($config['filter_fields'])) {
			$config['filter_fields'] = array(
				'id', 'm.id',	
				'shortcut', 'm.shortcut',
				'color', 'm.color',
				'title', 'm.title',
				'latitude', 'm.latitude',
				'longitude', 'm.longitude'
			);
		}

		parent::__construct($config);
	}
			
	protected function populateState($ordering = null, $direction = null){
		// Initialise variables.
		$app = JFactory::getApplication();

		// Adjust the context to support modal layouts.
		if ($layout = JRequest::getVar('layout')) {
			$this->context .= '.'.$layout;
		}

		// List state information.
		parent::populateState('m.id', 'asc');
	}

	/**
	 * Method to get a store id based on model configuration state.
	 *
	 * This is necessary because the model is used by the component and
	 * different modules that might need different sets of data or different
	 * ordering requirements.
	 *
	 * @param	string		$id	A prefix for the store id.
	 *
	 * @return	string		A store id.
	 * @since	1.6
	 */
	protected function getStoreId($id = '')
	{
		// Compile the store id.
		$id	.= ':'.$this->getState('filter.language');

		return parent::getStoreId($id);
	}
		
	protected function getListQuery() {
	
		// Create a new query object.
		$db = $this->getDbo();
		$query = $db->getQuery(true);

		// Select the required fields from the table.
		$query->select('m.id, m.shortcut, m.color, m.title, m.text, m.latitude, m.longitude');
		$query->from('#__mapycz_marks AS m');

		$query->where('m.mapId = '.$db->quote($this->map->id));
		
		$this->state->set('list.limit',0);
		
		// oreder
		$query->order($db->escape($this->getState('list.ordering', 'a.lft')) . ' ' . $db->escape($this->getState('list.direction', 'ASC')));
		
		//echo nl2br(str_replace('#__','jos_',$query));
		return $query;
	}
}
