<?php
/**
* @author   Vasatko
* @version  1.0
* @remarks  Copyright (C) 2011 Vasatko
* @remarks  Licensed under GNU/GPLv3, see http://www.gnu.org/licenses/gpl-3.0.html
* @see      http://vasatko.net/joomla/mapycz
*/

// no direct access
defined('_JEXEC') or die;

JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidator');

$https = !empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off';

$document = JFactory::getDocument();
$document->addStyleDeclaration("#mapycz td, #mapycz tr {border:0px !important;}");
$document->addScript(($https?"https":"http")."://api.mapy.cz/loader.js");
$document->addScriptDeclaration("Loader.load();");	

$user		= JFactory::getUser();
$userId		= $user->get('id');

// titulek
JToolBarHelper::title('&nbsp;','mapycz');

// tlacitka v toolbaru
JToolBarHelper::save('save', JText::_('MAPYCZ_BUTTON_SAVE'), false);
JToolBarHelper::cancel('cancel', JText::_('MAPYCZ_BUTTON_STORNO'), false);
	
$cnt = "
	
	// defaultni hlasky
	MAPYCZ_MARK_NOT_SAVED_MAP = '".JText::_("MAPYCZ_MARK_NOT_SAVED_MAP")."';
	MAPYCZ_MAP_NOT_SAVED_EXIT = '".JText::_("MAPYCZ_MAP_NOT_SAVED_EXIT")."';
	MAPYCZ_MAP_SAVED = '".JText::_("MAPYCZ_MAP_SAVED")."';	

	// vytvoreni pozic
	var coords = SMap.Coords.fromWGS84('".$this->map['latitude']."','".$this->map['longitude']."');
	
	// vytvoreni mapy
	var map = new SMap(JAK.gel('mapycz'), coords, ".$this->map['zoom'].");
	
	// fix pro nulove rozmery mapy uvnitr boxu na mapu
	box = map.getContainer();
	jQuery(function($) {
		inbox = $(box).children();
		inbox.each(function(i){
			if(i==0)
				$(this).css('width','".$this->map['width']."px');
				$(this).css('height','".$this->map['height']."px');
		});
	});
	

	// nastaveni zachycovani udalosti mysi
	var mouse = new SMap.Control.Mouse(SMap.MOUSE_PAN | SMap.MOUSE_WHEEL | SMap.MOUSE_ZOOM);
	map.addControl(mouse); 
	
	// nastaveni vrstvy
	var layer = '".$this->map['layer']."';
	if(layer=='turist')
		map.addDefaultLayer(SMap.DEF_TURIST).enable();
	else
		map.addDefaultLayer(SMap.DEF_TURIST);
	if(layer=='ophto')
		map.addDefaultLayer(SMap.DEF_OPHOTO).enable();
	else
		map.addDefaultLayer(SMap.DEF_OPHOTO);
	if(layer=='ophto0203')
		map.addDefaultLayer(SMap.DEF_OPHOTO0203).enable();
	else
		map.addDefaultLayer(SMap.DEF_OPHOTO0203);
	if(layer=='ophto0406')
		map.addDefaultLayer(SMap.DEF_OPHOTO0406).enable();
	else
		map.addDefaultLayer(SMap.DEF_OPHOTO0406);
	if(layer=='historic')
		map.addDefaultLayer(SMap.DEF_HISTORIC).enable();
	else
		map.addDefaultLayer(SMap.DEF_HISTORIC);
	if(layer=='base' || layer=='')
		map.addDefaultLayer(SMap.DEF_BASE).enable();
	else
		map.addDefaultLayer(SMap.DEF_BASE);

	if(layer == 'turist'){
		jQuery('#mapycz_turist_settings').css('display','block');
		map.getLayer(SMap.DEF_TURIST).setTrail(".($this->map['turist_ped']==1?'true':'false').");
		/*map.getLayer(SMap.DEF_TURIST).setBike(".($this->map['turist_ped']==1?'true':'false').");*/
	}else{
		jQuery('#mapycz_turist_settings').css('display','none');
	}
	
	// prepinac vrstev
	var layerSwitch = new SMap.Control.Layer();
	layerSwitch.addDefaultLayer(SMap.DEF_BASE);
	layerSwitch.addDefaultLayer(SMap.DEF_TURIST);
	layerSwitch.addDefaultLayer(SMap.DEF_OPHOTO);
	layerSwitch.addDefaultLayer(SMap.DEF_OPHOTO0203);
	layerSwitch.addDefaultLayer(SMap.DEF_OPHOTO0406);
	layerSwitch.addDefaultLayer(SMap.DEF_HISTORIC);
	map.addControl(layerSwitch,{left:'8px', top:'8px'});
	
	// nastaveni ovladacich prvku
	map.addDefaultControls();
	
	// pridani vrstvy pro znacku
	var layMarker = new SMap.Layer.Marker();
	map.addLayer(layMarker);
	layMarker.enable();

	// nastaveni udalosti pri taznei znacky
	var signals = map.getSignals();
	signals.addListener(window, 'map-redraw', mapycz_mapChange);
	signals.addListener(window, 'map-move', mapycz_mapChange);
	/*signals.addListener(window, '*', posluchac);*/
	signals.addListener(window, 'control-layer-click', mapycz_mapChange);  
	signals.addListener(window, 'marker-drag-stop', mapycz_markerDragStop);

	mapycz_mapChange();

	mapycz_loadMarkers('".$this->map['id']."');
	
";

?>
<script type="text/javascript">
	Joomla.submitbutton = function(task){
		
		if (task == 'save') {
			mapycz_saveMap('<?php echo JHtml::_('form.token')?>');
			return false;
			Joomla.submitform(task, document.getElementById('map-form'));
		}
		
		if (task == 'cancel') {
			if(!mapycz_checkSave(false)){
				if(!confirm(MAPYCZ_MAP_NOT_SAVED_EXIT))
					return false;
			}
			location.replace('<?php echo JRoute::_('index.php?option=com_mapycz')?>');
		}
		
	}
</script>

<h1><?php echo JText::_('MAPYCZ_EDIT')?></h1>

<div id="mapycz-map-edit">
	<form action="<?php echo JRoute::_('index.php?option=com_mapycz')?>" method="post" name="adminForm" id="map-form" class="form-validate">
	
		<table>
		
			<tr>
				<td>
					<?php echo JText::_('MAPYCZ_FIELD_NAME')?>:
				</td>
				<td>
					<input type="text" id="mapycz_name" class="required maxLength:255" name="name" value="<?php echo $this->map['name']?>" />
				</td>
			</tr>
		
			<tr>
				<td>
					<?php echo JText::_('MAPYCZ_FIELD_WIDTH')?>:
				</td>
				<td>	
					<input type="text" id="mapycz_width" class="validate-integer maxLength:10 small" name="width" onBlur="mapycz_mapSizeChange();" value="<?php echo $this->map['width']?>" /> px
				</td>
			</tr>
		
			<tr>
				<td>
					<label for="width_responsive" class="hasTip" title="<?php echo JText::_('MAPYCZ_FIELD_WIDTH_RESPONSIVE_DESC')?>"><?php echo JText::_('MAPYCZ_FIELD_WIDTH_RESPONSIVE')?>:</label>
				</td>
				<td>
					<input type="checkbox" id="mapycz_width_responsive" class="checkbox" name="width_responsive" <?php echo ($this->map['width_responsive']==1)?'checked="checked"':''?> />
				</td>
			</tr>
			
			<tr valign="top">
				<td>
					<?php echo JText::_('MAPYCZ_FIELD_HEIGHT')?>:
				</td>
				<td>
					<input type="text" id="mapycz_height" class="validate-integer maxLength:10 small" name="height" onBlur="mapycz_mapSizeChange();" value="<?php echo $this->map['height']?>" /> px
				</td>
			</tr>
		
			<tr valign="top" >
				<td>
					<label for="controls" class="hasTip" title="<?php echo JText::_('MAPYCZ_FIELD_CONTROLS_DESC')?>"><?php echo JText::_('MAPYCZ_FIELD_CONTROLS')?>:</label>
				</td>
				<td>
					<input type="checkbox" id="mapycz_controls" class="checkbox" name="controls" <?php echo ($this->map['controls']==1)?'checked="checked"':''?> />
				</td>
			</tr>
		
			<tr valign="top" >
				<td>
					<label for="clusterer" class="hasTip" title="<?php echo JText::_('MAPYCZ_FIELD_CLUSTERER_DESC')?>"><?php echo JText::_('MAPYCZ_FIELD_CLUSTERER')?>:</label>
				</td>
				<td>
					<input type="checkbox" id="mapycz_clusterer" class="checkbox" name="clusterer" <?php echo ($this->map['clusterer']==1)?'checked="checked"':''?> />
				</td>
			</tr>
		
			<tr valign="top">
				<td colspan="2">
					<br/>
					<?php echo JText::_('MAPYCZ_MAP_DESC')?><br/>
					<div onmouseup="mapycz_mapChange();" id="mapycz" style="height:<?php echo $this->map['height']?>px; width:<?php echo $this->map['width']?>px;"></div>
					<br/>
					<div id="mapycz_turist_settings" style="display: none">
						<input type="checkbox" id="mapycz_turist_ped" class="checkbox" name="turist_ped" <?php echo ($this->map['turist_ped']==1)?'checked="checked"':''?> /> <?php echo JText::_('MAPYCZ_MAP_TURIST_ROUTES')?><br/>
						<!--<input type="checkbox" id="mapycz_turist_cyc" class="checkbox" name="turist_cyc" <?php echo ($this->map['turist_cyc']==1)?'checked="checked"':''?> /> <?php echo JText::_('MAPYCZ_MAP_TURIST_CYC')?><br/>-->
					</div>
				</td>
			</tr>
				
		</table>

		<input type="hidden" id="mapycz_zoom" name="zoom" value="<?php echo $this->map['zoom']?>" />
		<input type="hidden" id="mapycz_layer" name="layer" value="<?php echo $this->map['layer']?>" />
		<input type="hidden" id="mapycz_latitude" name="latitude" value="<?php echo htmlentities($this->map['latitude'],ENT_COMPAT,"UTF-8")?>" />
		<input type="hidden" id="mapycz_longitude" name="longitude" value="<?php echo htmlentities($this->map['longitude'],ENT_COMPAT,"UTF-8")?>" />
		<input type="hidden" id="mapycz_id" name="cid" value="<?php echo $this->map['id']?>" />
	</form>
</div>
<div id="mapycz-map-marks"></div>
<div id="mapycz-temps"></div>
<div class="clr"></div>

<script type="text/javascript"><?php echo $cnt?></script>